Welcome to the TsExpressDecorators project wiki! 

This wiki contains informations to developp your application with decorators, to create your own Controllers, Converters, Decorators, Middlewares and Services.
* [Installation](https://github.com/Romakita/ts-express-decorators/wiki/Installation)
* [Quick start](https://github.com/Romakita/ts-express-decorators/wiki/Quick-start)
* [Examples](https://github.com/Romakita/ts-express-decorators/wiki/Examples)
* [Controllers](https://github.com/Romakita/ts-express-decorators/wiki/Controllers)
  * [Installation](https://github.com/Romakita/ts-express-decorators/wiki/Controllers#installation)
  * [Response and Request](https://github.com/Romakita/ts-express-decorators/wiki/Controllers#response-and-request)
  * [PathParams, BodyParams, QueryParams](https://github.com/Romakita/ts-express-decorators/wiki/Controllers#pathparams-bodyparams-queryparams)
  * [Header](https://github.com/Romakita/ts-express-decorators/wiki/Controllers#header)
  * [Use promise](https://github.com/Romakita/ts-express-decorators/wiki/Controllers#use-promise)
  * [Custom middleware](https://github.com/Romakita/ts-express-decorators/wiki/Controllers#custom-middleware)
  * [Controller dependencies](https://github.com/Romakita/ts-express-decorators/wiki/Controllers#controller-dependencies)
* [Services](https://github.com/Romakita/ts-express-decorators/wiki/Services)
  * [Installation](https://github.com/Romakita/ts-express-decorators/wiki/Services#installation)
  * [Declaring a service](https://github.com/Romakita/ts-express-decorators/wiki/Services#declaring-a-service)
  * [Declaring a service already constructed (Factory)](https://github.com/Romakita/ts-express-decorators/wiki/Services#declaring-a-service-already-constructed-factory)
  * [Inject ExpressApplication](https://github.com/Romakita/ts-express-decorators/wiki/Services#inject-expressapplication)
  * [Services available](https://github.com/Romakita/ts-express-decorators/wiki/Services#services-available)
  * [Converters](https://github.com/Romakita/ts-express-decorators/wiki/Converters)
* [Middlewares](https://github.com/Romakita/ts-express-decorators/wiki/Middlewares)
  * [Installation](https://github.com/Romakita/ts-express-decorators/wiki/Middlewares#installation)
  * [Specifics parameters decorators](https://github.com/Romakita/ts-express-decorators/wiki/Middlewares#specifics-parameters-decorators)
  * [Declaring a global middleware](https://github.com/Romakita/ts-express-decorators/wiki/Middlewares#declaring-a-global-middleware)
  * [Declaring a global error middleware](https://github.com/Romakita/ts-express-decorators/wiki/Middlewares#declaring-a-global-error-middleware)
  * [Declaring a middleware for an endpoint](https://github.com/Romakita/ts-express-decorators/wiki/Middlewares#declaring-a-middleware-for-an-endpoint)
    * [Simple use case](https://github.com/Romakita/ts-express-decorators/wiki/Middlewares#simple-use-case)
    * [Create your own decorator](https://github.com/Romakita/ts-express-decorators/wiki/Middlewares#create-your-own-decorator)
    * [How to format the Response with middleware](https://github.com/Romakita/ts-express-decorators/wiki/Middlewares#how-to-format-the-response-with-middleware)
  * [Declaring an error middleware for an endpoint](https://github.com/Romakita/ts-express-decorators/wiki/Middlewares#declaring-an-error-middleware-for-an-endpoint)
* [ServerLoader](https://github.com/Romakita/ts-express-decorators/wiki/Class:-ServerLoader)
  * [Configure server with decorator](https://github.com/Romakita/ts-express-decorators/wiki/Configure-server-with-decorator)
  * [API](https://github.com/Romakita/ts-express-decorators/wiki/Class:-ServerLoader----API)
  * [Versioning Rest API](https://github.com/Romakita/ts-express-decorators/wiki/Class:-ServerLoader-Versioning-Rest-API)
  * [Lifecycle hooks](https://github.com/Romakita/ts-express-decorators/wiki/Class:-ServerLoader---Lifecycle-Hooks)
  * [Middlewares settings](https://github.com/Romakita/ts-express-decorators/wiki/Class:-ServerLoader---Lifecycle-Hooks#serverloaderonmountingmiddlewares-void--promise)
  * [Serve static](https://github.com/Romakita/ts-express-decorators/wiki/Class:-ServerLoader---Lifecycle-Hooks#serverloaderafterroutesinit-void--promise)
  * [Authentification](https://github.com/Romakita/ts-express-decorators/wiki/Class:-ServerLoader---Lifecycle-Hooks#serverloaderonauthrequest-response-next-void)
  * [Global errors handlers](https://github.com/Romakita/ts-express-decorators/wiki/Class:-ServerLoader---Lifecycle-Hooks#serverloaderonerrorerror-request-response-next-void)
* [Templating](https://github.com/Romakita/ts-express-decorators/wiki/Templating)
* [Upload files with Multer](https://github.com/Romakita/ts-express-decorators/wiki/Upload-files-with-multer)
* [Throw HTTP exceptions](https://github.com/Romakita/ts-express-decorators/wiki/Throw-HTTP-Exceptions)
* [Testing](https://github.com/Romakita/ts-express-decorators/wiki/Testing)
  * [Unit test](https://github.com/Romakita/ts-express-decorators/wiki/Testing#unit-test)
    * [Installation](https://github.com/Romakita/ts-express-decorators/wiki/Testing#installation)
    * [Testing services](https://github.com/Romakita/ts-express-decorators/wiki/Testing#testing-services)
    * [Testing controllers](https://github.com/Romakita/ts-express-decorators/wiki/Testing#testing-controllers)
    * [Testing converters](https://github.com/Romakita/ts-express-decorators/wiki/Testing#testing-converters)
    * [Testing middlewares](https://github.com/Romakita/ts-express-decorators/wiki/Testing#testing-middlewares)
  * [Test your REST API](https://github.com/Romakita/ts-express-decorators/wiki/Testing#test-your-rest-api)
    * [Installation](https://github.com/Romakita/ts-express-decorators/wiki/Testing#installation-1)
    * [Example](https://github.com/Romakita/ts-express-decorators/wiki/Testing#test-your-rest-api)
* [API references](https://github.com/Romakita/ts-express-decorators/wiki/API-references)